routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

//Admin
Route::group(['namespace' => 'App\Http\Controllers'], function () {
    // Route::get('import','ImportController@import_products');
    Route::group(['prefix' => 'admin', 'namespace' => 'Admin'], function () {
        // Auth
        Route::group(['namespace' => 'Auth'], function () {
            Route::get('login-admin', 'LoginController@showLoginForm')->name('admin_login_form');
            Route::post('login-admin', 'ConfirmPasswordController@login')->name('admin_login');
            Route::post('logout-admin', 'LoginController@logout')->name('admin_logout');
        });
        Route::group(['middleware' => 'auth'], function () {
            // Dashboard
            Route::get('dashboard', 'DashboardController@index')->name('dashboard.index');
            // All
            Route::resource('users', 'UserController');
            Route::post('users/create/fetch', 'UserController@fetch_category_data')->name('category.fetch');

            // Clients
            Route::resource('clients', 'ClientController');
            //Cities
            Route::resource('cities', 'CityController');
            // // Stores
            // Route::resource('stores', 'StoreController');
            // Route::resource('stores/{store}/tags', 'StoreTagController');
            // Route::put('stores/{store}/cover', 'StoreController@update_cover')->name('stores.update_cover');
            // Route::resource('stores/{store}/offers', 'StoreOfferController');
            // products
            Route::resource('products', 'ProductsController');
            Route::resource('products/{product}/specs', 'SpecsController');
            Route::get('products', 'ProductsController@all_index')->name('all_products.index');
            Route::put('products/{product}/to_review', 'ProductsController@to_review')->name('products.to_review');
            Route::put('products/{product}/to_approve', 'ProductsController@to_approve')->name('products.to_approve');
            Route::put('products/{product}/to_reject', 'ProductsController@to_reject')->name('products.to_reject');
            Route::put('products/{product}/to_offline', 'ProductsController@to_offline')->name('products.to_offline');

            // //offers
            // Route::resource('products/{product}/offers', 'ProductOffersController');
            ////
            Route::put('products/{product}/update_image', 'ProductsController@update_image')->name('products.update_image');
            Route::post('products/{product}/add_image', 'ProductsController@add_image')->name('products.add_image');
            Route::delete('products/{product}/product_image/{product_image}', 'ProductsController@remove_image')->name('products.remove_image');
            //Orders
            Route::resource('orders', 'OrderController');
            Route::put('orders/{order}/confirm', 'OrderController@confirm')->name('orders.confirm');
            Route::put('orders/{order}/shipped', 'OrderController@shipped')->name('orders.shipped');
            Route::get('orders/{order}/print', 'PrintController@prnpriview')->name('orders.print');

            Route::put('orders/{order}/in_shipping', 'OrderController@in_shipping')->name('orders.in_shipping');

            //shipments
            Route::get('shipments', 'ShipmentsController@index')->name('shipments.index');
            Route::put('shipments/{shipment}', 'ShipmentsController@confirm')->name('shipments.confirm');
            //reviews
            Route::resource('stores/{store}/reviews', 'ProductsController');
            //Banners
            Route::resource('banners', 'BannerController');
            // Categories
            Route::resource('categories', 'CategoryController');
            Route::resource('categories/{category}/subs', 'SubCategoryController');
            // Notifications
            Route::resource('notifications', 'NotificationController', ['only' => ['index', 'create', 'store']]);
            //Tags Presets
            Route::resource('tags_presets', 'TagsPresetsController');
            Route::resource('tags_presets/{tags_preset}/tags_params', 'TagsPresetsParametersController');
        });
    });


    //Website
    Route::group(['namespace' => 'Website'], function () {
        // Auth
        Route::group(['namespace' => 'Auth', 'middleware' => 'guest'], function () {
            Route::get('login', 'LoginController@showLoginForm')->name('login');
            Route::get('signup', 'LoginController@showRegisterForm')->name('signup');
            Route::post('login', 'LoginController@login')->name('confirm_login');
            Route::post('signup', 'LoginController@signup')->name('confirm_signup');

        });
        Route::post('logout', 'Auth\LoginController@logout')->name('logout');


        //home page
        Route::get('/', function () {
            return redirect()->route('home');
        });
        Route::get('/home', 'HomeController@index')->name('home');
        //products
        Route::get('/products', 'Products\ProductsController@index')->name('products');
        Route::get('/products/{product}', 'Products\ProductsController@show')->name('product');
        //cart
        Route::get('/cart-test', function () {
            return view('website.cart');
        });
        Route::group(['namespace' => 'Cart'], function () {
            Route::get('cart', 'CartController@index')->name('cart.index');
            Route::post('cart/{product}/store', 'CartController@store')->name('cart.store');
            Route::delete('cart/empty', 'CartController@empty')->name('cart.empty');
            Route::delete('cart/{product}/remove', 'CartController@remove')->name('cart.remove');
        });

        Route::group(['middleware' => 'auth'], function () {
            Route::group(['namespace' => 'Profile'], function () {
                //addresses
                Route::get('MyAddresses/index', 'AddressesController@index')->name('web.myaddresses.index');
                Route::get('MyAddresses/create', 'AddressesController@create')->name('web.myaddresses.create');
                Route::get('MyAddresses/{address}/edit', 'AddressesController@edit')->name('web.myaddresses.edit');
                Route::put('MyAddresses/{address}/update', 'AddressesController@update')->name('web.myaddresses.update');
                Route::delete('MyAddresses/{address}/destroy', 'AddressesController@destroy')->name('web.myaddresses.destroy');
                Route::post('MyAddresses/store', 'AddressesController@store')->name('web.myaddresses.store');

                //wislists
                Route::get('MyWishlists', 'WishlistsController@index')->name('web.mywishlists.index');
                Route::get('MyWishlists/create', 'WishlistsController@create')->name('web.mywishlists.create');
                Route::post('MyWishlists/add', 'WishlistsController@add')->name('web.mywishlists.add');
                Route::put('MyWishlists/update', 'WishlistsController@update')->name('web.mywishlists.update');
                Route::delete('MyWishlists/{wishlist_product}/remove', 'WishlistsController@remove')->name('web.mywishlists.remove');
                Route::delete('MyWishlists/{wishlist}/destroy', 'WishlistsController@destroy')->name('web.mywishlists.destroy');
                Route::post('MyWishlists/store', 'WishlistsController@store')->name('web.mywishlists.store');
            });

            //orders
            Route::group(['namespace' => 'Orders'], function () {
                Route::get('MyOrders', 'OrdersController@index')->name('web.myorders.index');
                Route::get('MyOrders/{order}/order', 'OrdersController@show')->name('web.myorders.show');
                Route::post('checkout', 'OrdersController@get_checkout')->name('web.checkout');
                Route::post('checkout/place_order/{order}', 'OrdersController@place_order')->name('web.orders.place_order');
            });
        });
    });
});

app/Models/Product.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Kyslik\ColumnSortable\Sortable;

class Product extends Model
{
    //
    use Sortable;
    use HasFactory;


    const STATUS_ONLINE = 1;
    const STATUS_INREVIEW = 2;
    const STATUS_REJECTED = 3;
    const STATUS_OFFLINE = 4;
    const STATUS_DRAFT = 5;
    protected $fillable = ['sub_category_id', 'name', 'price', 'stock', 'color', 'size', 'fabric', 'image', 'description', 'branch', 'product_code'];
    public $sortable = ['id', 'name', 'sub_category_id', 'status', 'rate', 'ordered', 'sub_category_id', 'size', 'color', 'fabric', 'stock', 'price', 'created_at'];
    public $sortableAs = ['reviews_count'];

    public function reviews()
    {
        return $this->hasMany('App\Models\ProductReview', 'product_id');
    }
    public function specs()
    {
        return $this->hasMany('App\Models\ProductSpec', 'product_id');
    }
    public function getImageAttribute($value)
    {
        if ($value) {
            return asset('files/products/images/' . $value);
        } elseif($this->cover)
        {
            return $this->cover->small_image;

        }
        else{
            return asset('files/products/images/notfound.png');
        }
    }
    public function sub_category()
    {
        return $this->belongsTo('App\Models\SubCategory', 'sub_category_id');
    }
    public function offer()
    {
        return $this->hasOne('App\Models\ProductOffer', 'product_id');
    }
    public function group()
    {
        return $this->belongsToMany('App\Models\Group', 'group_products', 'product_id', 'group_id');
    }
    public function collections()
    {
        return $this->belongsToMany('App\Models\Collection');
    }
    public function cover(){
        return $this->hasOne('App\Models\ProductImage', 'product_id');

    }
    public function images()
    {
        return $this->hasMany('App\Models\ProductImage', 'product_id');
    }
}

app/Models/Wishlist.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Wishlist extends Model
{
    //
    public $sortable = ['name','created_at' ];
    public $sortableAs = ['products_count'];

    public function products()
    {
        return $this->hasMany('App\Models\WishlistProduct','wishlist_id');
    }
    public function getImageAttribute($value)
    {
        return asset('files/wishlists/images/'.$value);
    }

}

app/Http/Controllers/Website/Products/ProductsController.php
<?php

namespace App\Http\Controllers\Website\Products;

use App\Http\Controllers\Controller;
use App\Models\Category;
use App\Models\Collection;
use App\Models\Product;
use App\Models\SubCategory;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;

class ProductsController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        //
        $data =new Product();
        if($request->query('collection_id')) $data=Collection::where('id',$request->query('collection_id'))->firstOrFail()->products();
        $collections=Collection::get();

        if($request->query('sub_category')){
            $data=$data->where('sub_category_id', $request->query('sub_category'));
        }
        if($request->query('sub_category_name')){
            $categories= Category::where('name','like', '%'.$request->query('sub_category_name').'%')->pluck('id');
            $subs=SubCategory::whereIn('category_id',$categories)->pluck('id');
            $data=$data->whereIn('sub_category_id',$subs);
        }

        if($request->query('search')) $data=$data->where('name','like', '%'.$request->query('search').'%');
        if($request->query('filter')=="new_in") $data=$data->orderBy('created_at','asc');
        if(!$data) $data=Product::orderBy('ordered','desc');
         $data =$data->with('offer')->inRandomOrder()->paginate(20);
        return view('website.products.index',compact('data','collections'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show(Request $request ,Product $product)
    {
        //
        $products = $product->group()->first()->products();
        $varients= $products->get(['products.id','image','color','product_id','size','fabric'])->groupBy('color');
        $current_products=$products->where('color',$product->color);
        $sizes= $current_products->get(['id','size']);
        $product_images= $product->images()->get();
        $similar_products=Product::with('offer')->where('sub_category_id',$product->sub_category->id)->inRandomOrder()->limit(5)->get();
        return view('website.products.show',compact('product','varients','product_images','sizes','similar_products'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

resources/views/products/index.blade.php
@extends('layouts.resource.index')
@section('create-btn')
<a href="{{ route('products' . '.create') }}" class=" clr-blue p-2 "><i class="fas fa-plus"></i></a>
@endsection
@section('title', 'ادارة المنتجات')


@section('search-filter')
    <!-- Search and Filters START-->
    <form class="form " action="{{ route('all_products' . '.index') }}" method="get">
        <div class="d-flex justify-content-between">
            <div class="p-2 flex-fill ">
                @include('layouts.includes.forms.form_text',['field' => ['name' => 'name', 'text' => 'User' ]])
                <input type="text" class="form-control mb-2 mr-sm-2" name="product_code" placeholder="البحث بالكود ..." value="{{ request()->query('product_code') }}">

            </div>
            <div class="p-2 row flex-fill">
                <div class=" col form-group">
                    <select name="status" class="custom-select">
                        <option value="0"  @if(request()->query('status') == '0') selected @endif>الحالة...</option>
                        <option value="{{App\Models\Product::STATUS_ONLINE}}"  @if(request()->query('status') == App\Models\Product::STATUS_ONLINE) selected @endif>اونلاين</option>
                        <option value="2"  @if(request()->query('status') == '2') selected @endif>تحت الفحص</option>
                        <option value="3" @if(request()->query('status') == '3') selected @endif>مرفوض</option>
                        <option value="4" @if(request()->query('status') == '4') selected @endif>اوفلاين</option>
                        <option value="5" @if(request()->query('status') == '5') selected @endif>درافت</option>

                    </select>
                </div>

            </div>
            <div class="p-2 flex-fill ">
                <button type="submit" class="btn btn-block btn-primary  mb-2">تصفية</button>
            </div>
            <a href="{{ route('all_products'. '.index') }}" class="small-header-bold"> X</a>
        </div>
    </form>
    <!-- Search and Filters END-->
@endsection

@section('table-body')

@section('table-header')

        <th scope="col">@sortablelink('id', '#')</th>
        <th scope="col">الصورة</th>
        <th scope="col">@sortablelink('product_code','كود المنتج')</th>
        <th scope="col">@sortablelink('name','المنتج')</th>
        {{-- <th scope="col">@sortablelink('store_id','المحل')</th> --}}
        <th scope="col">@sortablelink('sub_catogrey_id','تصفية فرعية')</th>
        <th scope="col">@sortablelink('price','السعر')</th>
        {{-- <th scope="col">Visits</th> --}}
        <th scope="col">@sortablelink('ordered','طلبت')</th>
        <th scope="col">@sortablelink('stock','فى المخزون')</th>
        <th scope="col">@sortablelink('status','الحالة')</th>
        <th scope="col">@sortablelink('created_at','وقت الاضافة') </th>
        <th scope="col">العمليات </th>
@endsection
@section('table-body')
@foreach($products as $product)
<!------------------------------------------------------------- Rows START---------------------------------------------------------------------------->


<td>{{ $product->id }}</td>
<td><img src={{$product->image}} class="pp-square"></td>
<td>{{ Str::limit($product->name ,70) }} </td>
<td>{{ $product->product_code }}  </td>

{{-- <td>{{ Str::limit($product->store->name ,70) }} </td> --}}
<td>{{ $product->sub_category->name }}  </td>
<td>{{ $product->price }} EGP </td>
{{-- <td>{{ $product->visited }} </td> --}}
<td>{{ $product->ordered }} </td>
<td>{{ $product->stock }} </td>

<td>
    @if ($product->status == 1)
    <span class="badge badge-success text-white">اونلاين</span>
    @elseif ($product->status == 2)
    <span class="badge badge-primary text-black">تحت الفحص</span>
    @elseif ($product->status == 3)
    <span class="badge badge-danger text-white">مرفوض</span>
    @elseif ($product->status == 4)
    <span class="badge bg-dark text-white  ">اوفلاين</span>
    @elseif ($product->status == 5)
    <span class="badge bg-dark text-white text-black">درافت</span>
    @else
    <span class="badge bg-dark text-white text-black">غير محدد</span>
    @endif
</td>

<td>
    @php
    Carbon\Carbon::setlocale("ar");
    echo Carbon\Carbon::parse($product->created_at)->diffForHumans()
    @endphp
</td>

<!------------------------------------------------------------- Rows START---------------------------------------------------------------------------->

<td class="d-flex justify-content-center">
    <a href="{{ route('products.create',["product_code"=>$product->product_code]) }}"
        class="btn btn-primary  "><i class="fas fa-plus"></i></a>
    <a href="{{ route('products.show',[$product->id]) }}"
    class="btn clr-black  "><i class="fas fa-eye"></i></a>
   <a href="{{ route('products.edit', [$product->id]) }}"
     class="btn clr-black "><i class="fas fa-edit"></i></a>
       <form method="POST" action="{{ route('products.'.'destroy',[$product->id]) }}">
           {{ csrf_field() }}
           {{ method_field('DELETE') }}
           <button type="submit"
            onclick="return confirm('Are you sure you want to delete this product?')"
            data-toggle="modal" data-target="#exampleModal"
       class="btn  clr-blue  bg-transparent"><i class="fas fa-trash-alt "></i></button>
       </form>
   </td>
</tr>
@endforeach
@endsection
    {{ $data->appends(request()->query())->links() }}
@section('table-footer')
<p class="table-footer">النتائج :  {{$data->total()}}</p>

@endsection
@endsection